import * as PF from 'pathfinding';
import * as PIXI from 'pixi.js';
import * as filters from 'pixi-filters';
import * as CUTE from './2C';

declare global {
   interface AudioParam {
      interpolate(duration: number, ...points: number[]): Promise<void>;
      modulate(duration: number, ...points: number[]): Promise<void>;
   }
   type X2 = CUTE.X2;
   type XAnchoredObjectProperties = CUTE.XAnchoredObjectProperties;
   type XAnimationData<A extends string = string> = CUTE.XAnimationData<A>;
   type XAnimationProperties = CUTE.XAnimationProperties;
   type XAnimationResources = CUTE.XAnimationResources;
   type XArea = CUTE.XArea;
   type XAtlasProperties<A extends string = string> = CUTE.XAtlasProperties<A>;
   type XAudio = CUTE.XAudio;
   type XBasic = CUTE.XBasic;
   type XCardinal = CUTE.XCardinal;
   type XCharacterPreset = CUTE.XCharacterPreset;
   type XCharacterProperties = CUTE.XCharacterProperties;
   type XColor = CUTE.XColor;
   type XCrop = CUTE.XCrop;
   type XData<A extends XBasic = XBasic> = CUTE.XData<A>;
   type XDefined<A> = CUTE.XDefined<A>;
   type XEntityProperties = CUTE.XEntityProperties;
   type XFont = CUTE.XFont;
   type XFontData = CUTE.XFontData;
   type XFrames = CUTE.XFrames;
   type XGlyph = CUTE.XGlyph;
   type XGlyphData = CUTE.XGlyphData;
   type XHandler<A extends unknown, B extends any[] = any> = CUTE.XHandler<A, B>;
   type XImage = CUTE.XImage;
   type XInputProperties = CUTE.XInputProperties;
   type XInstance = CUTE.XInstance;
   type XInventory<A extends CUTE.XAsset<any>[] = CUTE.XAsset<any>[]> = CUTE.XInventory<A>;
   type XKeyed<A = any, B extends string = any> = CUTE.XKeyed<A, B>;
   type XListener<A extends unknown, B extends any[]> = CUTE.XListener<A, B>;
   type XNavigatorKey<A extends string = string> = CUTE.XNavigatorKey<A>;
   type XNavigatorProperties<A extends string = string> = CUTE.XNavigatorProperties<A>;
   type XNot<A, B extends string> = CUTE.XNot<A, B>;
   type XObjectParent = CUTE.XObjectParent;
   type XObjectProperties = CUTE.XObjectProperties;
   type XPrimitive<A> = CUTE.XPrimitive<A>;
   type XProperties<A extends XKeyed<any, any>, B extends keyof A> = CUTE.XProperties<A, B>;
   type XProvider<A, B extends any[] = []> = CUTE.XProvider<A, B>;
   type XRegion = CUTE.XRegion;
   type XRendererLayerModifier = CUTE.XRendererLayerModifier;
   type XRendererLayerProperties = CUTE.XRendererLayerProperties;
   type XRendererProperties = CUTE.XRendererProperties;
   type XResult<A> = CUTE.XResult<A>;
   type XRouter = CUTE.XRouter;
   type XShader = CUTE.XShader;
   type XSide = CUTE.XSide;
   type XSizedObjectProperties = CUTE.XSizedObjectProperties;
   type XSpriteProperties = CUTE.XSpriteProperties;
   type XStyle = CUTE.XStyle;
   type XTextProperties = CUTE.XTextProperties;
   type XTransform = CUTE.XTransform;
   class XAnchoredObject extends CUTE.XAnchoredObject {}
   class XAnimation extends CUTE.XAnimation {}
   class XAsset<A = any> extends CUTE.XAsset<A> {}
   class XAtlas<A extends string = string> extends CUTE.XAtlas<A> {}
   class XCache<A, B> extends CUTE.XCache<A, B> {}
   class XCharacter extends CUTE.XCharacter {}
   class XDaemon extends CUTE.XDaemon {}
   class XEffect extends CUTE.XEffect {}
   class XEntity extends CUTE.XEntity {}
   class XHitbox extends CUTE.XHitbox {}
   class XHost<A extends XKeyed<any[]>> extends CUTE.XHost<A> {}
   class XInput extends CUTE.XInput {}
   class XMixer extends CUTE.XMixer {}
   class XModule<A, B extends any[]> extends CUTE.XModule<A, B> {}
   class XNavigator<A extends string = string> extends CUTE.XNavigator<A> {}
   class XNumber extends CUTE.XNumber {}
   class XObject extends CUTE.XObject {}
   class XPlayer extends CUTE.XPlayer {}
   class XRandom extends CUTE.XRandom {}
   class XRectangle extends CUTE.XRectangle {}
   class XRenderer<A extends string = string> extends CUTE.XRenderer<A> {}
   class XRendererLayer extends CUTE.XRendererLayer {}
   class XSizedObject extends CUTE.XSizedObject {}
   class XSprite extends CUTE.XSprite {}
   class XText extends CUTE.XText {}
   class XVector extends CUTE.XVector {}
   const PF: typeof import('pathfinding'),
      PIXI: typeof import('pixi.js') & { filters: typeof filters },
      X: typeof CUTE.X;
}

Object.assign(PIXI.filters, filters);
Object.assign(globalThis, { PF, PIXI }, CUTE);
